package com.xhkjedu.sexam.service.paperstudent;

import com.xhkjedu.sexam.mapper.paper.EPaperMapper;
import com.xhkjedu.sexam.mapper.paperstudent.EScanbatchMapper;
import com.xhkjedu.sexam.model.paperstudent.EScanbatch;
import com.xhkjedu.utils.N_Utils;
import org.springframework.stereotype.Repository;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: TODO
 * @Author: wn
 * @CreateTime: 2022-08-11  09:31
 */
@Service
public class EScanbatchService {
    @Resource
    private EScanbatchMapper eScanbatchMapper;
    @Resource
    private EPaperMapper ePaperMapper;

    /**
     * @description: 保持扫描试卷批次信息
     * @param: [eScanbatch]
     * @return: java.util.Map
     * @author: wn
     * @date: 2022/8/11/011 9:42
     **/
    public Map saveScanBatch(EScanbatch eScanbatch){
        String batchname = eScanbatch.getBatchname() + "-" + eScanbatch.getEpid() + "-";
        //获取数据库中该批次名的扫描批次数量
        Integer bnum = eScanbatchMapper.getBatchNameLikeNum(batchname);
        if(bnum == null || bnum == 0){
            bnum = 1;
        }else{
            bnum++;
        }
        batchname = batchname + bnum;
        //对应考试id
        Integer examid = ePaperMapper.getExamIdByEpId(eScanbatch.getEpid());
        eScanbatch.setBatchname(batchname);
        eScanbatch.setExamid(examid);
        eScanbatch.setScannum(0);
        eScanbatch.setErrornum(0);
        eScanbatch.setQknum(0);
        eScanbatch.setWgnum(0);
        eScanbatch.setCreatetime(N_Utils.getSecondTimestamp());
        eScanbatchMapper.insertUseGeneratedKeys(eScanbatch);
        Integer batchid = eScanbatch.getId();
        Map rtnmap = new HashMap<>();
        rtnmap.put("batchid",batchid);
        rtnmap.put("batchname",batchname);
        return rtnmap;
    }
}
